Index: GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoMeshSimplifier.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoMeshSimplifier.h	(revision 2090)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoMeshSimplifier.h	(revision 2127)
@@ -90,7 +90,4 @@
 			void	JoinVertices(Mesh *mesh);
 
-			MeshSimplificationSequence *
-				WriteRealSimpSeq(MeshSimplificationSequence *simpseq);
-
 			Mesh	*GetMesh();
 	};
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/buffers.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/buffers.h	(revision 2127)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/buffers.h	(revision 2127)
@@ -0,0 +1,46 @@
+#ifndef __interleave_h_
+#define __interleave_h_
+
+#include "GL/glut.h"
+
+#include "color.h"
+#include "mesh.h"
+#include "change.h"
+
+namespace	VMI
+{
+
+typedef struct _VertexIL {
+    float tx, ty;       // texture coordinates
+    GLubyte r, g, b, a; // color
+    float x, y, z;      // position coordinates
+} VertexIL;
+
+typedef struct _Vertex_{
+    float x, y, z;    // position
+} Vertex_;
+
+extern GLuint vertex_buf, color_buf;
+
+extern Vertex_ *buf_vertices;
+extern Color   *buf_colors;
+
+extern Vertex_ *pbuf_vertices;
+extern Color   *pbuf_colors;
+
+extern void saveVertexBuffer(Change *c, VertexIL *dest);
+extern void loadVertexBuffer(VertexIL *src, Change *c);
+
+extern VertexIL *setupInterleave(Mesh *mesh, Color *colors);
+extern void setupVertexArray(Mesh *mesh, Color *colors);
+extern void updateVertexArray(Mesh *mesh, Change *c);
+extern void setupVertexBufferObjects(Mesh *mesh, Color *colors);
+extern void updateVertexBufferObjects(Mesh *mesh, Change *c);
+extern void printInterleave(VertexIL *interleave, int num);
+extern void updateAllColorInterleave(VertexIL *interleave, int num, Color *colors);
+extern void updateColorInterleave(VertexIL *interleave, int num, Color *colors, int begin, int end);
+extern void fillColorInterleave(VertexIL *interleave, int num, int begin, int end, GLubyte color);
+
+}
+
+#endif
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/mesh.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/mesh.h	(revision 2090)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/mesh.h	(revision 2127)
@@ -7,7 +7,9 @@
 
 typedef struct _Vertex {
-    GLfloat x, y, z;     // Vertex coordinates
-    GLuint numTriangles; // Number of triangles 
-    GLuint *triangles;   // List of triangles
+    float x, y, z;     // Vertex coordinates
+    int numTriangles; // Number of triangles 
+    int *triangles;   // List of triangles
+		int numEdges;
+	  int *edges;
     int enable;
 		int	movable;	//	If vertex is part of a border.
@@ -15,19 +17,16 @@
 
 typedef struct _Edge {
-    GLuint u, v;         // Edge vertices
-    GLuint *triangles;   // Edge triangles
-    GLuint numTriangles; // Number of triangles
+    int u, v;         // Edge vertices
     int enable;
 } Edge;
 
 typedef struct _Triangle {
-    GLuint		id;         // Triangle id
-    GLuint  group;        // Triangle group
-		GLuint		submesh;		// Triangle submesh	
-    GLuint		indices[3]; // Triangle vertices
-    GLuint		edges[3];   // Triangle edges
-    GLfloat		normal[3];  // Triangle normal
-    GLdouble	area;       // Triangle area
-    GLdouble	saliency;   // Triangle saliency
+    int		id;         // Triangle id
+    int  group;        // Triangle group
+		int		submesh;		// Triangle submesh	
+    int		indices[3]; // Triangle vertices
+    float		normal[3];  // Triangle normal
+    double	area;       // Triangle area
+    double	saliency;   // Triangle saliency
     int				enable;
 } Triangle;
@@ -35,20 +34,22 @@
 typedef struct _Mesh {
     Vertex *vertices;           // Mesh vertices
-    GLuint numVertices;         // Number of vertices
-    GLuint currentNumVertices;  // Current number of vertices
+    int numVertices;         // Number of vertices
+    int currentNumVertices;  // Current number of vertices
     Edge *edges;                // Mesh edges
-    GLuint numEdges;            // Number of edges
+    int numEdges;            // Number of edges
     Triangle *triangles;        // Mesh triangles
-    GLuint numTriangles;        // Number of triangles
-    GLuint currentNumTriangles; // Current number of triangles
+    int numTriangles;        // Number of triangles
+    int currentNumTriangles; // Current number of triangles
 } Mesh;
 
 extern GLdouble computeTriangleArea(Vertex *vertices, Triangle *t);
+extern double computeEdgeLength(Vertex *vertices, int u, int v);
 extern void computeTriangleNormal(Vertex *vertices, Triangle *t);
+extern double computeTriangleVolume(Vertex *vertices, Triangle *t);
 
 extern Vertex *addVertex(Vertex *list, int *n, float x, float y, float z, int *pos);
-extern int findEdge(Edge *e, GLuint num, GLuint _u, GLuint _v);
+extern int findEdge(Edge *e, int num, int _u, int _v);
 extern Edge *addEdge(Edge *list, int *n, int u, int v, int *pos);
-extern GLboolean findVertex(GLfloat *vertices, GLuint num, GLfloat x, GLfloat y, GLfloat z, int *pos);
+extern GLboolean findVertex(float *vertices, int num, float x, float y, float z, int *pos);
 
 extern Mesh *initMesh(GLMmodel* pmodel);
@@ -56,9 +57,8 @@
 extern void printMesh(Mesh *mesh);
 extern void saveModel(char *filename, GLMmodel* pmodel, Mesh *mesh);
-extern void updateModel(GLMmodel* pmodel, Mesh *mesh, GLuint numVertices, GLuint numTriangles);
+extern void updateModel(GLMmodel* pmodel, Mesh *mesh, int numVertices, int numTriangles);
 
 extern int *trianglesAdjToEdge(Mesh *mesh, int e, int *n);
 extern int *verticesAdjToVertex(Mesh *mesh, int v, int *n);
-extern int *edgesAdjToVertex(Mesh *mesh, int v, int *n);
 extern int *edgesAdjToVertices(Mesh *mesh, int *vertices, int numVertices, int *n);
 
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/simplify.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/simplify.h	(revision 2090)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/simplify.h	(revision 2127)
@@ -19,9 +19,8 @@
 	extern bheap_t *updateHeap(bheap_t *h, Mesh *mesh, Change *c);
 
-	extern void simplifyModel(Mesh *mesh, GLuint numDemandedTri);
+	extern void simplifyModel(Mesh *mesh, int numDemandedTri);
 
 
 	extern void bh_mydump(Mesh *mesh, bheap_t *h);
-	extern GLdouble computeEdgeLength(Vertex *vertices, int u, int v);
 
 	extern void chooseBestEndPoints(Mesh *mesh, int e);
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/histogram.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/histogram.h	(revision 2090)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/histogram.h	(revision 2127)
@@ -11,17 +11,17 @@
 {
 
-extern void getSubHistogram(GLuint subHistoGram[][4]);
-extern void copySubHistogram(Color *colors, GLuint *histogram, GLuint begin, GLuint end, GLuint subHistoGram[][4]);
-extern void printHistogram(GLuint histoGram[][4]);
-extern void plotHistogram(GLuint histoGram[][4]);
+extern void getSubHistogram(int subHistoGram[][4]);
+extern void copySubHistogram(Color *colors, int *histogram, int begin, int end, int subHistoGram[][4]);
+extern void printHistogram(int histoGram[][4]);
+extern void plotHistogram(int histoGram[][4]);
 
-extern GLuint **initHistogram(GLuint numTriangles, GLuint numCameras);
-extern void deleteHistogram(GLuint **histogram, GLuint numCameras);
-extern void printFullHistogram(GLuint **histogram, GLuint numCameras, GLuint numTriangles);
-extern void getSWHistogram(GLuint *histogram, GLubyte *pixels);
-extern void getSWHistogramWin(GLuint *histogram, GLubyte *pixels, GLfloat min[3], GLfloat max[3], Change *c);
-extern void getSWHistoByOcclusionQuery(Mesh *mesh, Color *colors, GLuint *histogram);
+extern int **initHistogram(int numTriangles, int numCameras);
+extern void deleteHistogram(int **histogram, int numCameras);
+extern void printFullHistogram(int **histogram, int numCameras, int numTriangles);
+extern void getSWHistogram(int *histogram, GLubyte *pixels);
+extern void getSWHistogramWin(int *histogram, GLubyte *pixels, GLfloat min[3], GLfloat max[3], Change *c);
+extern void getSWHistoByOcclusionQuery(Mesh *mesh, Color *colors, int *histogram);
 
-extern void resetSWHistogram(GLuint *histogram, GLuint numTriangles);
+extern void resetSWHistogram(int *histogram, int numTriangles);
 extern void getBoundingBox(Change *c, GLfloat min[3], GLfloat max[3]);
 extern void getWindow(GLfloat min[3], GLfloat max[3], int minw[2], int maxw[2]);
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/global.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/global.h	(revision 2090)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/global.h	(revision 2127)
@@ -60,4 +60,6 @@
 //#define SALIENCY
 
+#define CHECK_LOCAL_INVERSION
+
 // Extension added into the filename
 #ifdef KL // Kullback-Leibler
@@ -73,6 +75,4 @@
 #define EXT "VCS"
 #endif
-
-//#define USE_EDGE_ADJACENCY
 
 #define CHECK_OPENGL_ERROR( cmd ) \
@@ -109,10 +109,10 @@
 
 extern Camera *cameras;
-extern GLuint numCameras;
+extern int numCameras;
 
 extern Color *colors;
 
-extern GLuint **histogram,
-               *queries;
+extern int **histogram;
+extern GLuint *queries;
 
 extern Mesh *mesh;
@@ -122,5 +122,5 @@
 extern GLdouble  radius;
 extern GLdouble  fov;
-extern GLuint    numDemandedTriangles,
+extern int    numDemandedTriangles,
                  cameraType;
 extern GLboolean bBeQuiet,
@@ -138,6 +138,7 @@
 extern void init(void);
 
-extern void renderScene(GLuint **histogram, GLuint numCameras);
-extern void renderSceneWin(GLuint **histogram, GLuint numCameras, Change *c);
+extern void resetProjectedAreas(int **histogram, int numCameras);
+extern void getProjectedAreas(int **histogram, int numCameras);
+extern void getProjectedAreasWin(int **histogram, int numCameras, Change *c);
 
 extern void renderGeometry(void);
@@ -150,4 +151,5 @@
 
 extern void applyHWAcceleration(void);
+extern void updateHWAcceleration(Change *c);
 extern void setOrthographicProjection(void);
 extern void resetPerspectiveProjection(void);
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/metrics.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/metrics.h	(revision 2090)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/metrics.h	(revision 2127)
@@ -8,25 +8,21 @@
 namespace	VMI
 {
-extern GLdouble computeMI(Mesh *mesh, GLuint **histogram, GLuint numCameras, GLuint cam);
-extern GLdouble decMI(GLdouble I, GLuint **histogram, GLuint numCameras, GLuint cam, Change *c);
-extern GLdouble incMI(GLdouble I, GLuint **histogram, GLuint numCameras, GLuint cam, Change *c);
+extern GLdouble computeMI(Mesh *mesh, int **histogram, int numCameras, int cam);
+extern GLdouble decMI(GLdouble I, int **histogram, int numCameras, int cam, Change *c);
+extern GLdouble incMI(GLdouble I, int **histogram, int numCameras, int cam, Change *c);
 
-extern GLdouble computeHE(Mesh *mesh, GLuint *histogram);
-extern GLdouble computeKL(Mesh *mesh, GLuint *histogram);
-extern GLdouble computeCS(Mesh *mesh, GLuint *histogram);
+extern GLdouble computeHE(Mesh *mesh, int *histogram);
+extern GLdouble computeKL(Mesh *mesh, int *histogram);
+extern GLdouble computeCS(Mesh *mesh, int *histogram);
 
-extern GLdouble computeMeanProjArea(GLuint **histogram, GLuint numCameras, int t);
-extern GLdouble computeJS(GLuint **histogram, GLuint numCameras, GLuint j, GLuint k);
-extern GLdouble computeEntropy(GLuint **histogram, GLuint numCameras, GLuint k);
-extern GLdouble computeMixedEntropy(GLdouble *mixed, GLuint numCameras);
-extern GLdouble computeMeanProjAreaNoBG(GLuint **histogram, GLuint numCameras, int t);
+extern GLdouble computeMeanProjArea(int **histogram, int numCameras, int t);
+extern GLdouble computeJS(int **histogram, int numCameras, int j, int k);
+extern GLdouble computeEntropy(int **histogram, int numCameras, int k);
+extern GLdouble computeMixedEntropy(GLdouble *mixed, int numCameras);
+extern GLdouble computeMeanProjAreaNoBG(int **histogram, int numCameras, int t);
 
-extern void getProjectedAreas(GLuint **histogram, GLuint numCameras);
-extern void getProjectedAreasWin(GLuint **histogram, GLuint numCameras, Change *c);
-extern void resetProjectedAreas(GLuint **histogram, GLuint numCameras);
-
-extern GLdouble *initIs(GLuint numCameras);
-extern void computeCameraIs(GLuint **histogram, GLuint numCameras, GLdouble *mis);
-extern void printIs(GLdouble *mis, GLuint numCameras);
+extern GLdouble *initIs(int numCameras);
+extern void computeCameraIs(int **histogram, int numCameras, GLdouble *mis);
+extern void printIs(GLdouble *mis, int numCameras);
 }
 #endif
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/saliency.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/saliency.h	(revision 2090)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/saliency.h	(revision 2127)
@@ -13,8 +13,8 @@
 extern double percentile;
 
-extern void computeSaliency(Mesh *mesh, GLuint **histogram, GLuint numCameras);
-extern void updateTriangleSaliency(Mesh *mesh, GLuint **histogram, GLuint numCameras, int v);
+extern void computeSaliency(Mesh *mesh, int **histogram, int numCameras);
+extern void updateTriangleSaliency(Mesh *mesh, int **histogram, int numCameras, int v);
 
-extern double computeTriangleSaliency(Mesh *mesh, GLuint **histogram, GLuint numCameras, GLuint k);
+extern double computeTriangleSaliency(Mesh *mesh, int **histogram, int numCameras, int k);
 
 extern double computeEdgeSaliency(Mesh *mesh, Change *c, double p);
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/vmi_simplifier.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/vmi_simplifier.h	(revision 983)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/vmi_simplifier.h	(revision 2127)
@@ -13,4 +13,4 @@
 #include "saliency.h"
 #include "simplify.h"
-#include "interleave.h"
+#include "buffers.h"
 
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/color.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/color.h	(revision 2090)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/color.h	(revision 2127)
@@ -14,11 +14,11 @@
 } Color;
 
-extern Color *initColors(GLuint numColors);
-extern void fillAllColors(Color *colors, GLuint numColors, GLuint begin, GLuint end, GLubyte color);
-extern void setColors(Color *colors, GLuint numPasses, GLuint begin, GLuint end);
-extern void setColors2(Color *colors, GLuint numColors, GLuint begin, GLuint end);
-extern void setColors3(Color *colors, GLuint numColors, GLubyte color);
-extern void setColors4(Color *colors, GLuint numColors);
-extern void viewColors(Color *colors, GLuint numColors);
+extern Color *initColors(int numColors);
+extern void fillAllColors(Color *colors, int numColors, int begin, int end, GLubyte color);
+extern void setColors(Color *colors, int numPasses, int begin, int end);
+extern void setColors2(Color *colors, int numColors, int begin, int end);
+extern void setColors3(Color *colors, int numColors, GLubyte color);
+extern void setColors4(Color *colors, int numColors);
+extern void viewColors(Color *colors, int numColors);
 
 }
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/change.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/change.h	(revision 2090)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/change.h	(revision 2127)
@@ -68,7 +68,7 @@
 	extern void modifyTriangle(Triangle *t, int c, int p);
 	extern int isATriangleToModify(Triangle *t, int c);
-	extern Triangle *getTrianglesToModify(Mesh *mesh, Change *c, GLuint *numMod);
+	extern Triangle *getTrianglesToModify(Mesh *mesh, Change *c, int *numMod);
 	extern int isATriangleToDelete(Triangle *t, int c, int p);
-	extern Triangle *getTrianglesToDelete(Mesh *mesh, Change *c, GLuint *numDel);
+	extern Triangle *getTrianglesToDelete(Mesh *mesh, Change *c, int *numDel);
 
 	extern void modifyTriangles(Mesh *mesh, Change *c);
@@ -85,5 +85,6 @@
 
 	extern void modifyEdges(Mesh *mesh, Change *c);
-  extern void deleteEdges(Mesh *mesh, Change *c);
+  extern int find(int *edges, int num, int v_);
+	extern void updateEdgeAdj(Mesh *mesh, Change *c) ;
 
 	//	Save simplification sequence in Geometry Game Tools format.
@@ -92,6 +93,5 @@
 	//extern std::map<int, INTVECTOR> inversemap;
 	extern void swap(int *i, int *j);
-	extern int hasEdge(Triangle *t, int e);
-	extern void getEdges(Triangle *t, Change *c, int *d, int *a);
+
 }
 #endif
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/camera.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/camera.h	(revision 2090)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/camera.h	(revision 2127)
@@ -18,10 +18,10 @@
 } Camera;
 
-extern Camera *loadCameras(GLdouble radius, char* filename, GLuint *numCameras);
-extern void saveCameras(char* filename, Camera *cameras, GLuint numCameras);
+extern Camera *loadCameras(GLdouble radius, char* filename, int *numCameras);
+extern void saveCameras(char* filename, Camera *cameras, int numCameras);
 extern void copyToCameras(Camera *cameras, int numVertices, GLdouble vertices[][3]);
-extern void setCameraWeights(Camera *cameras, GLuint numCameras, GLdouble *weights);
-extern Camera *setCameras(GLdouble radius, GLuint type, GLuint *numCameras);
-extern void printCameras(Camera *cameras, GLuint numCameras);
+extern void setCameraWeights(Camera *cameras, int numCameras, GLdouble *weights);
+extern Camera *setCameras(GLdouble radius, int type, int *numCameras);
+extern void printCameras(Camera *cameras, int numCameras);
 
 extern void drawSphere(Camera *cameras, GLdouble radius, int slices, int stacks);
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/metrics.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/metrics.cpp	(revision 2090)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/metrics.cpp	(revision 2127)
@@ -13,6 +13,6 @@
 using namespace	VMI;
 
-GLdouble VMI::computeMeanProjAreaNoBG(GLuint **histogram, GLuint numCameras, int t) {
-    GLuint i;
+GLdouble VMI::computeMeanProjAreaNoBG(int **histogram, int numCameras, int t) {
+    int i;
     GLdouble mean_proj_area = 0.0;
 
@@ -24,6 +24,6 @@
 }
 
-GLdouble VMI::computeMeanProjArea(GLuint **histogram, GLuint numCameras, int t) {
-	GLuint i;
+GLdouble VMI::computeMeanProjArea(int **histogram, int numCameras, int t) {
+	int i;
 	GLdouble mean_proj_area = 0.0, total_proj_area, resolution = width * height;
 
@@ -38,7 +38,7 @@
 ///////////////////////////////////////////////////////////////////////////////
 // Mutual Information
-GLdouble VMI::computeMI(Mesh *mesh, GLuint **histogram, GLuint numCameras, GLuint cam) {
+GLdouble VMI::computeMI(Mesh *mesh, int **histogram, int numCameras, int cam) {
     GLdouble I = 0.0, pov, po, total_proj_area = width * height;
-    GLuint i;
+    int i;
     
     for (i=0; i<mesh->numTriangles; i++) { 
@@ -66,5 +66,5 @@
 }
 
-GLdouble VMI::decMI(GLdouble I, GLuint **histogram, GLuint numCameras, GLuint cam, Change *c) {
+GLdouble VMI::decMI(GLdouble I, int **histogram, int numCameras, int cam, Change *c) {
     GLdouble newI = I * numCameras, 
              pov = 0.0, po;
@@ -109,12 +109,12 @@
 }
 
-GLdouble VMI::incMI(GLdouble I, GLuint **histogram, GLuint numCameras, GLuint cam, Change *c) {
+GLdouble VMI::incMI(GLdouble I, int **histogram, int numCameras, int cam, Change *c) {
     GLdouble newI = I * numCameras, 
              pov = 0.0, po;
     GLsizei total_proj_area = width * height;
-    GLuint i, t;
+    int i, t;
 
     // increase entropy of modified triangles
-    for (i=0; i<(GLuint)c->numMod; i++) { 
+    for (i=0; i<c->numMod; i++) { 
         
         t = c->modified[i].id;
@@ -140,9 +140,9 @@
 ///////////////////////////////////////////////////////////////////////////////
 // Kullback-Leibler divergence
-GLdouble VMI::computeKL(Mesh *mesh, GLuint *histogram) {
+GLdouble VMI::computeKL(Mesh *mesh, int *histogram) {
     GLdouble I = 0.0, 
              total_real_area = 0.0, pi, tri_area;
     GLsizei  total_proj_area = (width * height) - histogram[0];
-    GLuint   i;
+    int   i;
 
     // Compute total real area of all triangles
@@ -169,9 +169,9 @@
 
 // Hellinger divergence (square root)
-GLdouble VMI::computeHE(Mesh *mesh, GLuint *histogram) {
+GLdouble VMI::computeHE(Mesh *mesh, int *histogram) {
     GLdouble I = 0.0, temp, 
              total_real_area = 0.0, pi, qi;
     GLsizei  total_proj_area = (width * height) - histogram[0];
-    GLuint i;
+    int i;
     
     // Compute total real area of all triangles
@@ -203,9 +203,9 @@
 
 // Chi-Square divergence (square root)
-GLdouble VMI::computeCS(Mesh *mesh, GLuint *histogram) {
+GLdouble VMI::computeCS(Mesh *mesh, int *histogram) {
     GLdouble I = 0.0, 
              total_real_area = 0.0, pi, qi;
     GLsizei  total_proj_area = (width * height) - histogram[0];
-    GLuint i;
+    int i;
     
     /// Compute total real area of all triangles
@@ -231,8 +231,8 @@
 }
 ///////////////////////////////////////////////////////////////////////////////
-GLdouble VMI::computeEntropy(GLuint **histogram, GLuint numCameras, GLuint k) {
+GLdouble VMI::computeEntropy(int **histogram, int numCameras, int k) {
 	GLdouble H = 0.0, POk, pi,
 					 total_proj_area, resolution = width * height, pv = 1.0 / (GLdouble)numCameras;
-	GLuint i;
+	int i;
 
 	for (i=0; i<numCameras; i++) {
@@ -253,7 +253,7 @@
 }
 
-GLdouble VMI::computeMixedEntropy(GLdouble *mixed, GLuint numCameras) {
+GLdouble VMI::computeMixedEntropy(GLdouble *mixed, int numCameras) {
     GLdouble H = 0.0, pi;
-    GLuint i;
+    int i;
     
     for (i=0; i<numCameras; i++) {
@@ -269,9 +269,9 @@
 ///////////////////////////////////////////////////////////////////////////////
 // Jensen-Shannon divergence
-GLdouble VMI::computeJS(GLuint **histogram, GLuint numCameras, GLuint j, GLuint k) {
+GLdouble VMI::computeJS(int **histogram, int numCameras, int j, int k) {
 	GLdouble js, Wj = 0.0, Wk = 0.0, POj, POk, pj, pk, total_proj_area,
 					 resolution = width * height, pv = 1.0 / (GLdouble)numCameras,
 					 *mixing = (GLdouble *)malloc(numCameras * sizeof(GLdouble));
-	GLuint i;
+	int i;
 
 	POj = computeMeanProjArea(histogram, numCameras, j + 1);
@@ -311,23 +311,6 @@
 }
 ///////////////////////////////////////////////////////////////////////////////
-void VMI::getProjectedAreas(GLuint **histogram, GLuint numCameras) {
-
-    renderScene(histogram, numCameras);
-}
-
-void VMI::getProjectedAreasWin(GLuint **histogram, GLuint numCameras, Change *c) {
-
-    renderSceneWin(histogram, numCameras, c);
-}
-
-void VMI::resetProjectedAreas(GLuint **histogram, GLuint numCameras) {
-    GLuint i = 0;
-
-    // Reset the projected areas for all cameras
-    for (i=0; i<numCameras; i++)
-        resetSWHistogram(histogram[i], mesh->numTriangles);
-}
-
-GLdouble *VMI::initIs(GLuint numCameras) {
+
+GLdouble *VMI::initIs(int numCameras) {
     GLdouble *initialIs;
 
@@ -346,6 +329,6 @@
 }
 
-void VMI::computeCameraIs(GLuint **histogram, GLuint numCameras, GLdouble *mis) {
-    GLuint i = 0;
+void VMI::computeCameraIs(int **histogram, int numCameras, GLdouble *mis) {
+    int i = 0;
     GLdouble meanI = 0.0;
 
@@ -374,6 +357,6 @@
 }
 
-void VMI::printIs(GLdouble *mis, GLuint numCameras) {
-    GLuint i;
+void VMI::printIs(GLdouble *mis, int numCameras) {
+    int i;
 
     printf("\n");
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/saliency.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/saliency.cpp	(revision 2090)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/saliency.cpp	(revision 2127)
@@ -22,6 +22,6 @@
 using namespace VMI;
 
-void VMI::computeSaliency(Mesh *mesh, GLuint **histogram, GLuint numCameras) {
-	GLuint i = 0;
+void VMI::computeSaliency(Mesh *mesh, int **histogram, int numCameras) {
+	int i = 0;
 	double sal;
 
@@ -46,5 +46,5 @@
 }
 
-void updateTriangleSaliency(Mesh *mesh, GLuint **histogram, GLuint numCameras, int v) {
+void updateTriangleSaliency(Mesh *mesh, int **histogram, int numCameras, int v) {
 	int i, t;
 
@@ -57,6 +57,6 @@
 }
 
-double VMI::computeTriangleSaliency(Mesh *mesh, GLuint **histogram, GLuint numCameras, GLuint k) {
-     GLuint i, l, v0, v1, v2;
+double VMI::computeTriangleSaliency(Mesh *mesh, int **histogram, int numCameras, int k) {
+    int i, l, v0, v1, v2;
     int *triangles = NULL, n = 0;
     double sal = 0.0;
@@ -94,5 +94,5 @@
     //printItemList(triangles, n);
     
-    for(i=0; i<(GLuint)n; i++) {
+    for(i=0; i<n; i++) {
         //printf("\n%d %d", k, triangles[i]);
         //sal += computeJS(histogram, numCameras, k, triangles[i]);
@@ -137,5 +137,5 @@
 void VMI::saveSaliencyMap(Mesh *mesh, char* filename) {
     FILE *fp;
-    GLuint i;
+    int i;
 
 
@@ -162,5 +162,5 @@
 void VMI::loadSaliencyMap(Mesh *mesh, char* filename) {
     FILE *fp;
-    unsigned int i, num;
+    int i, num;
     float s;
 
@@ -202,5 +202,5 @@
 
 void VMI::viewSaliency(Mesh *mesh, Camera *cameras, int cam) {
-    GLuint i, v1, v2, v3;
+    int i, v1, v2, v3;
     float r, g, b;
     
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/color.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/color.cpp	(revision 2090)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/color.cpp	(revision 2127)
@@ -7,5 +7,5 @@
 using namespace VMI;
 
-Color *VMI::initColors(GLuint numColors) {
+Color *VMI::initColors(int numColors) {
     Color *colors;
 
@@ -25,6 +25,6 @@
 }
 
-void VMI::fillAllColors(Color *colors, GLuint numColors, GLuint begin, GLuint end, GLubyte color) {
-    GLuint i;
+void VMI::fillAllColors(Color *colors, int numColors, int begin, int end, GLubyte color) {
+    int i;
 
     if (end > numColors) return;
@@ -40,6 +40,6 @@
 }
 
-void VMI::setColors(Color *colors, GLuint numPasses, GLuint begin, GLuint end) {
-    GLuint i, step = numPasses * MAX_NUM_COLORS;
+void VMI::setColors(Color *colors, int numPasses, int begin, int end) {
+    int i, step = numPasses * MAX_NUM_COLORS;
     GLubyte r = 1,
             g = 1,
@@ -86,6 +86,6 @@
 }
 
-void VMI::setColors2(Color *colors, GLuint numColors, GLuint begin, GLuint end) {
-    GLuint i, 
+void VMI::setColors2(Color *colors, int numColors, int begin, int end) {
+    int i, 
         channel = 0,
         step = (numColors < MAX_NUM_COLORS) ? (MAX_NUM_COLORS / numColors) : 1;
@@ -133,6 +133,6 @@
 }
 
-void VMI::setColors3(Color *colors, GLuint numColors, GLubyte color) {
-    GLuint i;
+void VMI::setColors3(Color *colors, int numColors, GLubyte color) {
+    int i;
     
     for (i = 0; i < numColors; i++) {
@@ -148,6 +148,6 @@
 }
 
-void VMI::setColors4(Color *colors, GLuint numColors) {
-    GLuint i, c = 1;
+void VMI::setColors4(Color *colors, int numColors) {
+    int i, c = 1;
     
     for (i = 0; i < numColors; i++) {
@@ -164,6 +164,6 @@
 }
 
-void VMI::viewColors(Color *colors, GLuint numColors) {
-    GLuint i;
+void VMI::viewColors(Color *colors, int numColors) {
+    int i;
 
     printf("\n");
